package com.gyee.viewticket.controller.viewticket;


import com.gyee.viewticket.comm.domain.AjaxResult;
import com.gyee.viewticket.model.ticket.Labor;
import com.gyee.viewticket.service.ticket.LaborService;
import com.gyee.viewticket.service.ticket.WindturbineService;
import com.gyee.viewticket.service.ticket.WorkriskpoolService;
import com.gyee.viewticket.service.ticket.WorkticketService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author admin
 * @since 2021-03-09
 */
@RestController
@RequestMapping("/view/workticket")
public class WorkticketController {

    private static final Logger log = LoggerFactory.getLogger(WorkticketController.class);
    @Autowired
    WindturbineService windturbineService;

    @Autowired
    LaborService laborService;

    @Autowired
    private WorkticketService workticketService;

    @Autowired
    WorkriskpoolService workriskpoolService;

    /**
     * 按场站获取所有风机
     * @param deptnum 风机编号
     * @return
     */
    //@CrossOrigin(origins = "*",maxAge = 3600)
    @GetMapping(value = "windlist")
    public AjaxResult getWindturbineid(@RequestParam("deptnum")String deptnum) {
        if ("".equals(deptnum.trim())){
            return AjaxResult.error(500,"查询条件为空");
        }
        List<Map> list = windturbineService.getWindturbineList(deptnum);
        return AjaxResult.successData(list);
    }

    /**
     * 工作类型
     * @return
     */
    //@CrossOrigin(origins = "*",maxAge = 3600)
    @GetMapping(value = "list")
    public AjaxResult getWorkTypeList() {
        List<Map> list =workriskpoolService.getWorkriskpoolList();
        return  AjaxResult.successData(list);
    }


    /**
     * 根据场站获取员工
     * @param deptnum 场站名称
     * @return
     */
    //@CrossOrigin(origins = "*",maxAge = 3600)
    @GetMapping(value = "getLaborList")
    public AjaxResult getLaborNameList(@RequestParam("deptnum")String deptnum) {
        List<Labor> labors = laborService.getLaborList(deptnum);
        return AjaxResult.successData(labors);
    }

    /**
     * 按场站获取所有风机
     * @param workdept 工作单位
     * @param location 风机编号
     * @param description 维修部件
     * @param wspeed 风速
     * @param worktypeid 作业类型
     * @return
     */
    //@CrossOrigin(origins = "*",maxAge = 3600)
    @PostMapping(value = "addWindelec")
    public AjaxResult addWorkticket(@RequestParam("workdept")String workdept,
                                    @RequestParam("location")String location,
                                    @RequestParam("description")String description,
                                    @RequestParam("wspeed")String wspeed,
                                    @RequestParam("worktypeid")String worktypeid,
                                    @RequestParam("labornum")String labornum) {
        log.debug("请求数据:workdept={}&location={}&description={}&wspeed={}&worktypeid={}&labornum={}",
                workdept,location,description,wspeed,worktypeid,labornum);
        Labor labor =  laborService.getLaborItem(labornum);
        if (null!=labor){
            boolean result = workticketService.saveWorkticket(workdept,location,description,wspeed,worktypeid,labor.getLaborname());
            if (result){
                return AjaxResult.success();
            }
        }
        return AjaxResult.error(500, "数据操作失败");
    }

}

