package com.gyee.viewticket.service.impl.ticket;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.gyee.viewticket.model.ticket.Labor;
import com.gyee.viewticket.mapper.ticket.LaborMapper;
import com.gyee.viewticket.service.ticket.LaborService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.gyee.viewticket.util.TicketUtil;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author admin
 * @since 2021-03-09
 */
@Service
public class LaborServiceImpl extends ServiceImpl<LaborMapper, Labor> implements LaborService {

    @Override
    public List<Labor> getLaborList(String dept) {
        QueryWrapper<Labor> wrapper = new QueryWrapper<>();
        if (TicketUtil.allDept().contains(dept)){
            wrapper.in("DEPTNUM", dept);
        }

        List<Labor> labors = baseMapper.selectList(wrapper);

        return labors;
    }

    @Override
    public Labor getLaborItem(String laborNum) {
        QueryWrapper<Labor> wrapper = new QueryWrapper<>();
        wrapper.eq("LABORNUM", laborNum);

        Labor labor = baseMapper.selectOne(wrapper);
        return labor;
    }
}
