package com.gyee.viewticket.service.impl.ticket;

import com.gyee.viewticket.mapper.ticket.WoworktaskMapper;
import com.gyee.viewticket.model.ticket.Ibsidgen;
import com.gyee.viewticket.model.ticket.Workriskpool;
import com.gyee.viewticket.model.ticket.Workticket;
import com.gyee.viewticket.mapper.ticket.WorkticketMapper;
import com.gyee.viewticket.model.ticket.Woworktask;
import com.gyee.viewticket.service.ticket.*;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.gyee.viewticket.util.TicketUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author admin
 * @since 2021-03-09
 */
@Service
public class WorkticketServiceImpl extends ServiceImpl<WorkticketMapper, Workticket> implements WorkticketService {


    @Autowired
    IbsidgenService ibsidgenService;
    @Autowired
    WoworktaskMapper woworktaskMapper;
    @Autowired
    WorkticketMapper workticketMapper;
    @Autowired
    LocationsService locationsService;
    @Autowired
    WorkriskpoolService workriskpoolService;




    @Override
    public boolean saveWorkticket(String workdept, String location, String description, String wspeed, String worktypeid, String labornum) {
        Workticket workticket =  new Workticket();
        workticket.setWonum(String.valueOf(Integer.valueOf(workticketMapper.selectMaxWonum()) + 1));
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMM");
        String prefix = TicketUtil.getStationPrefix(workdept) + sdf.format(new Date());
        String endticketnum = workticketMapper.selectTicketnum("%"+prefix+"%");
        String  ticketnum = TicketUtil.getTicketNum(prefix, endticketnum);
        workticket.setTicketnum(ticketnum);//工作票编号
        workticket.setPrincipal(labornum);//工作负责人
        workticket.setStatus("流程未启动");//工作票状态
        workticket.setStatusdate(new Date());//开始时间
        workticket.setWtickettype("风场风机");
        workticket.setDeptgroup1("风机检修班");//工作班组
        workticket.setSitenum(workdept);
        workticket.setCorpnum("GUODIAN");//
        workticket.setGwnum("100.00");
        workticket.setFinaltype("极高风险");
        workticket.setWorkdept(workdept);//工作单位
        workticket.setWspeed(wspeed);//风速
        String wxbj = TicketUtil.getWxbj(description);
        if (wxbj.length()>0){
            String  loc = locationsService.gerDescription(location.trim(),wxbj.trim());
            workticket.setWtnum(loc.length()>0? loc:location);
        }else {
            workticket.setWtnum(location);//风电机编号
        }
        Ibsidgen gen = ibsidgenService.selectId("WORKTICKET");
        double id = gen.getIdvalue() + 1;
        ibsidgenService.updateGen(gen, id);
        workticket.setId(id);
        int code  = baseMapper.insert(workticket);
        if (code <= 0){
            return false;
        }

        Workriskpool pool = workriskpoolService.getWorkriskpool(worktypeid);
        Ibsidgen genPool = ibsidgenService.selectId("WOWORKTASK");
        double poolId = genPool.getIdvalue()+ 1;
        ibsidgenService.updateGen(genPool, poolId);
        Woworktask woworktask = new Woworktask();
        woworktask.setId(poolId);
        woworktask.setAddress("");
        woworktask.setLocation(pool.getWorkrisknum());
        woworktask.setDescription(pool.getDescription());
        woworktask.setWonum(workticket.getWonum());
        int code1  = woworktaskMapper.insert(woworktask);
        if (code1 <= 0){
            return false;
        }
        return true;

    }
}
