package com.gyee.viewticket.util;


import java.util.*;

/**
 * 工作票
 */
public class TicketUtil {

    /**
     * 返回所有场站集合
     *
     * @return
     */
    public static List<String> allDept(){
        List<String> list = new ArrayList<>();

        list.add("石板泉风电场");
        list.add("麻黄山风电场");
        list.add("牛首山风电场");
        list.add("香山风电场");
        list.add("青山风电场");
        list.add("平罗光伏电站");
        list.add("宣和光伏发电站");
        list.add("大武口电站");

        return list;
    }


    /**
     * 工作票类型
     *
     * @param type
     * @return
     */
    public static String ticketType(String type) {
        if (type == null)
            return null;

        switch (type) {
            case "wind":
                type = "风场风机";
                break;
            case "elec1":
                type = "电气一种";
                break;
            case "elec2":
                type = "电气二种";
                break;
            case "fire1":
                type = "风场动火";
                break;
            case "fire2":
                type = "二级动火";
                break;
            case "line1":
                type = "线路一种";
                break;
            case "line2":
                type = "线路二种";
                break;
        }

        return type;
    }








    /**
     * 流程角色转换为人员组
     *
     * @param role
     * @return
     */
    public static String roleFormat(String role) {
        String groupName = null;
        switch (role) {
            case "工作票签发人":
                groupName = "WTSIGNATORY";
                break;
            case "值班负责人":
                groupName = "SHIFTENGINEER";
                break;
            case "工作票许可人":
                groupName = "XUKEREN";
                break;
            case "经济运行人员":
                groupName = "ECONOMY";
                break;
            case "缺陷运行人员":
                groupName = "RUNUSER";
                break;
            case "检修人员":
                groupName = "CHECKREPAIRUSER";
                break;
            case "消防监护人":
                groupName = "FIRECONTROL";
                break;
        }

        return groupName;
    }

    /**
     * 各种票据的 name 映射
     *
     * @param wfName
     * @return
     */
    public static String wfNameFormat(String wfName) {
        String app = null;
        switch (wfName) {
            case "风电机组工作票":
                app = "WINDELEC";
                break;
            case "电气一种工作票":
                app = "ELEC1";
                break;
            case "电气二种工作票":
                app = "ELEC2";
                break;
            case "风场动火工作票":
                app = "WOMOVEFIRE";
                break;
            case "二级动火工作票":
                app = "WOMOVEFIRE2";
                break;
            case "线路一种工作票":
                app = "ELECFIRST";
                break;
            case "线路二种工作票":
                app = "ELECFIRST2";
                break;
        }

        return app;
    }



    /**
     * 获取项目的路径
     * @return
     */
    public static String absolutePath(){
        return System.getProperty("user.dir");
    }


    /**
     * 生成风机工作票编号
     * @param endticketnum
     * @return
     */
    public static String getTicketNum(String ticketnum, String endticketnum){
        if(endticketnum != null && endticketnum != ""){
            String num = endticketnum .substring(9);
            int number = Integer.valueOf(num) + 1;
            if(number < 10){
                ticketnum += ("0" + number);
            }else if(number < 100){
                ticketnum += number;
            }else{
                ticketnum += number;
            }
        }else{
            ticketnum += "01";
        }

        return ticketnum;
    }


    /**
     * 获取场站前缀
     * @param station
     * @return
     */
    public static String getStationPrefix(String station){
        switch (station) {
            case "麻黄山风电场":
                station = "麻";
                break;
            case "牛首山风电场":
                station = "牛";
                break;
            case "青山风电场":
                station = "青";
                break;
            case "石板泉风电场":
                station = "石";
                break;
            case "香山风电场":
                station = "香";
                break;
            default:
                station = "国";
                break;
        }

        return station + "FJ";
    }


    public static String getWxbj(String desc){
        switch (desc) {
            case "fdj":
                desc = "发电机系统";
                break;
            case "hh":
                desc = "滑环";
                break;
            case "clx":
                desc = "齿轮箱";
                break;
            case "dj":
                desc = "叶片";
                break;
            case "bpq":
                desc = "变频器";
                break;
            case "tdg":
                desc = "塔底控制柜";
                break;
            case "yyz":
                desc = "液压系统";
                break;
            case "phdj":
                desc = "偏航系统";
                break;
            default:
                desc = "";
                break;
        }

        return desc;
    }

}
